// A5.cpp : Defines the entry point for the application.
//
#include "stdafx.h"

#include <WindowsX.h>
#include "A5.h"
#include "UI.h"
#include "Glyphs.h"
#include "GlobalSettings.h"
#include <time.h>

#define MAX_LOADSTRING 100
const float TICK_LENGTH = 30;

struct RenderState
{
	HWND hWnd;
	HDC hdc;
	HGLRC hrc;
} gRenderState;

// Global Variables:
HINSTANCE hInst;								// current instance
char* szTitle = "Shooter488";				// The title bar text
char* szWindowClass = "Shooter488Class";		// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	//LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	//LoadString(hInstance, IDC_A5, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_A5));

	clock_t clockTickTime = clock() + TICK_LENGTH;

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if(clock()>clockTickTime) {
			TimerTickArgs args = {clock()-clockTickTime};
			OnTimerTick(args);
			InvalidateRect(gRenderState.hWnd, NULL, false);
			clockTickTime = clock() + TICK_LENGTH;
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_A5));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_A5);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
	   return FALSE;
   }

   gRenderState.hWnd = hWnd;
   gRenderState.hdc = GetDC(hWnd);

   // set the pixel format for the DC
   PIXELFORMATDESCRIPTOR pfd;
   ZeroMemory( &pfd, sizeof( pfd ) );
   pfd.nSize = sizeof( pfd );
   pfd.nVersion = 1;
   pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL |
	   PFD_DOUBLEBUFFER;
   pfd.iPixelType = PFD_TYPE_RGBA;
   pfd.cColorBits = 24;
   pfd.cDepthBits = 16;
   pfd.iLayerType = PFD_MAIN_PLANE;
   int format = ChoosePixelFormat(gRenderState.hdc, &pfd );
   SetPixelFormat(gRenderState.hdc, format, &pfd );

   UINT_PTR ret = SetTimer(hWnd, 0, TICK_LENGTH, NULL);
   DBG_ASSERT(ret);

   // create the render context (RC)
   gRenderState.hrc = wglCreateContext( gRenderState.hdc );

   // make it the current render context
   wglMakeCurrent(gRenderState.hdc, gRenderState.hrc);

   glewInit ();

   AppInitArgs args;
   OnAppInit(args);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void FreeInstance()
{
	if (gRenderState.hrc)
	{
		wglMakeCurrent(NULL, NULL);
		wglDeleteContext(gRenderState.hrc);
	}
	if (gRenderState.hWnd && gRenderState.hrc)
	{
		ReleaseDC(gRenderState.hWnd, gRenderState.hdc);
	}
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_CREATE:
		{
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
	case WM_TIMER:
		{
			TimerTickArgs args;
			args.dt = 0;
			OnTimerTick(args);
			//InvalidateRect(hWnd, NULL, false);
			return 0;
		}
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		{
			WindowPaintArgs args;
			RECT rect; 
			GetClientRect(gRenderState.hWnd, &rect);
			args.width = rect.right - rect.left;
			args.height = rect.bottom - rect.top;
			OnWindowPaint(args);
			SwapBuffers(gRenderState.hdc);
			break;
		}
	case WM_LBUTTONDOWN:
		{
			MouseBtnDownArgs args;
			args.btn = 1;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnDown(args);

			break;
		}
	case WM_MBUTTONDOWN:
		{
			MouseBtnDownArgs args;
			args.btn = 2;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnDown(args);

			break;
		}
	case WM_RBUTTONDOWN:
		{
			MouseBtnDownArgs args;
			args.btn = 3;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnDown(args);

			break;
		}
	case WM_LBUTTONUP:
		{
			MouseBtnUpArgs args;
			args.btn = 1;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnUp(args);

			break;
		}
	case WM_MBUTTONUP:
		{
			MouseBtnUpArgs args;
			args.btn = 2;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnUp(args);

			break;
		}
	case WM_RBUTTONUP:
		{
			MouseBtnUpArgs args;
			args.btn = 3;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			OnMouseBtnUp(args);

			break;
		}
	case WM_MOUSEMOVE:
		{
			MouseMoveArgs args;
			args.x = GET_X_LPARAM(lParam);
			args.y = GET_Y_LPARAM(lParam);
			args.b1 = wParam & MK_LBUTTON;
			args.b2 = wParam & MK_MBUTTON;
			args.b3 = wParam & MK_RBUTTON;
			//reproduce behaviour on gtk: only send event if button is down
			if(args.b1 || args.b2 || args.b3) OnMouseMove(args);
			break;
		}
	case WM_KEYDOWN:
		{
			KeyDownArgs args;
			args.key = (int)wParam;
			OnKeyDown(args);
			break;
		}
	case WM_KEYUP:
		{
			KeyUpArgs args;
			args.key = (int)wParam;
			OnKeyUp(args);
			break;
		}
	case WM_MOUSEWHEEL:
		{
			double zDelta = GET_WHEEL_DELTA_WPARAM(wParam);
			if(zDelta > 0) {
				ScrollUpArgs args;
				OnScrollUp(args);
			}
			else {
				ScrollDownArgs args;
				OnScrollDown(args);
			}
		break;
		}
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

#include <sstream>
#include <fstream>

void DebugAssert(bool exp, std::string expStr, std::string time, std::string file, int line)
{
	if(!exp) {
		std::ofstream logFile("log.txt");
		_ASSERT(0);
		logFile << "Assert failed: " << expStr << " at " << file << ":" << line;
		logFile.close();
		exit(1);
	}

}
