#pragma once
#include "Mesh.h"
#include "MissileList.h"
#include "Explosion.h"
#include <list>

class EnemyList
{
public:
	void Init();
	void AddEnemy(Point3D worldPos);
	void Update(Point3D cameraPos, Matrix4x4 cameraRot, MissileList& missiles, std::list<Explosion>& explosions, unsigned int& score, bool gameLogic);
	void Draw();
private:
	struct Enemy
	{
		Enemy(): dead(false) {}
		Point3D pos;
		Vector3D velocity;
		Matrix4x4 transform;
		bool dead;
	};
	static bool isDead (const Enemy& e);
	std::list<Enemy> m_enemies;
	Mesh* m_mesh;
};