#include "stdafx.h"
#include "EnvironmentMap.h"
#include "AssetManager.h"

EnvironmentMap::EnvironmentMap()
{
	m_transition = 0;
	m_bgNum = 0;
}

void EnvironmentMap::Load()
{
	m_cubeMesh = AssetManager::GetInstance()->GetMesh("envCube.obj");
	m_tex1 = AssetManager::GetInstance()->GetTexture("stormy");
	m_tex2 = AssetManager::GetInstance()->GetTexture("hills");
	m_tex3 = AssetManager::GetInstance()->GetTexture("mars");
	AssetManager::GetInstance()->AddParameter("Skybox background", &m_bgNum, 0, 2);
}

void EnvironmentMap::Draw()
{
	Texture* tex;
	if(m_bgNum == 0) tex = m_tex1;
	else if(m_bgNum == 1) tex = m_tex2;
	else if(m_bgNum == 2) tex = m_tex3;
	m_cubeMesh->DrawCubemap(tex, tex, m_transition);
}

Texture* EnvironmentMap::GetTexture()
{
	if(m_bgNum == 0) return m_tex1;
	else if(m_bgNum == 1) return m_tex2;
	else if(m_bgNum == 2) return m_tex3;
}