#pragma once
#include "algebra.h"
#include "Mesh.h"
#include "SubMesh.h"

class Explosion // deformable, post-process
{
public:
	Explosion(): m_done(false) {}
	void Draw();
	void Create(Point3D pos);
	void Update();
	Point3D GetPos() {return m_pos;}
	static bool IsDone(Explosion& e) {return e.m_done;}
private:
	Mesh* m_mesh; //implicity contains deform mesh
	float m_percent;
	Point3D m_pos;
	bool m_done;
};