#pragma once
#include "Mesh.h"
#include <list>

class MissileList
{
public:
	void Init();
	void AddMissile(Point3D worldPos, Vector3D dir, Matrix4x4 rot);
	void Update(Point3D cameraPos, Matrix4x4 cameraRot, float farplane, bool gameLogic);
	void Draw();
	bool CollidedWith(Point3D point, Vector3D boxRadius);
private:
	struct Missile
	{
		Point3D pos;
		Vector3D velocity;
		Vector3D dir; // coupled w/ above
		Matrix4x4 rot;
		Matrix4x4 transform;
	};
	static bool outOfBounds (const Missile& m);
	std::list<Missile> m_missiles;
	Mesh* m_mesh;
};