#pragma once
#include "stdafx.h"
#include "Random.h"
#include <math.h>

int RandInt(int lower, int upper){
	if(lower>=upper) return lower;
	return rand() % (upper-lower) + lower;
}

int RandInt(int upper){
	return rand() % upper;
}
double RandDouble(double upper){
	return upper * (float(rand()) / float(RAND_MAX));
}
double RandFrac() // returns a double result in [-1, 1]
{
	return (double)((rand()%200)-100)/100;
}

double RandUnsignedFrac() // returns a double result in [0, 1]
{
	return (double)((rand()%1000))/1000;
}

double randf()
{
	return (double)rand()/(double)RAND_MAX;
}

double Gaussian()
{
	// from http://www.taygeta.com/random/gaussian.html
	// Algorithm by Dr. Everett (Skip) Carter, Jr.

	float x1, x2, w, y1, y2;

	do {
		x1 = 2.0 * randf() - 1.0;
		x2 = 2.0 * randf() - 1.0;
		w = x1 * x1 + x2 * x2;
	} while ( w >= 1.0 );

	w = sqrt( (-2.0 * log( w ) ) / w );
	y1 = x1 * w;
	//y2 = x2 * w; // only need 1 random var
	return y1;
}

double Gaussian(double mean, double stddev)
{
	return Gaussian()*stddev + mean;
}

double GaussianUnsignedFrac(double mean, double stddev)
{
	double r = mean + (Gaussian()*stddev);
	if(r == 0) r = 0;
	if(r > 1) r = 1;
	return r;
}
