#include "stdafx.h"
#include "Shader.h"
#include <fstream>

void GetShaderDebugInfo(GLuint obj)
{
	int infologLength = 0;
	int charsWritten  = 0;
	char *infoLog;

	glGetShaderiv(obj, GL_INFO_LOG_LENGTH, &infologLength);

	if (infologLength > 0)
	{
		infoLog = (char *)malloc(infologLength);
		glGetShaderInfoLog(obj, infologLength, &charsWritten, infoLog);
		printf("%s\n",infoLog);
		free(infoLog);
	}
}

void Shader::Load(std::string fileName, unsigned int type)
{
	m_id = glCreateShader(type);

	//load shader file
	std::ifstream fileStrm(fileName.c_str());
	std::string str;
	if(!fileStrm.good()) {
		DBG_ASSERT(0);
	}
	while(fileStrm.good()){
		std::string line;
		getline(fileStrm, line);
		str += line + "\r\n";
	}
	const char* charBuf = str.c_str();
	int len = str.length();

	glShaderSource(m_id, 1, &charBuf, &len);
	glCompileShader(m_id);
	int result;
	glGetShaderiv(m_id, GL_COMPILE_STATUS, &result);
	if(result!=GL_TRUE) {
		GetShaderDebugInfo(m_id);
		DBG_ASSERT(0);
	}
	m_fileName = fileName;
}