#pragma once
#include "Shader.h"
#include <string>
#include <map>

class ShaderProgram
{
public:
	ShaderProgram(): m_instancing(0), m_deform(0), m_postProc(0){}
	void Compile(Shader& vs, Shader& fs, bool inst, bool dfm, bool post);
	unsigned int GetVarId(std::string name);
	unsigned int GetId() {return m_id;}
	bool SupportsInstancing() {return m_instancing;}
	bool UsesDeform() {return m_deform;}
	bool Is2ndPass() {return m_postProc;}

private:
	struct Variable
	{
		std::string name;
		int size;
		GLenum type;
		unsigned int location;
	};
	unsigned int m_id;
	bool m_compiled;
	unsigned int m_VS;
	unsigned int m_FS;
	std::map<std::string, Variable> m_vars;
	bool m_instancing;
	bool m_deform;
	bool m_postProc;
};