#pragma once

class Slider
{
public:
	Slider(std::string s, float* pval): m_label(s), m_percent(pval), m_picked_up(false), m_type(PERCENT), dragDelta(0) {}
	Slider(std::string s, unsigned int* pval, unsigned int lo, unsigned int hi):m_label(s), m_discrete(pval), m_picked_up(false), m_type(DISCRETE), dragDelta(0), m_hi(hi), m_lo(lo) {}
	void Draw(unsigned int index, float maxx, float maxy);
	bool IsOnHotspot(unsigned int index, float maxx, float maxy, Point2D pos);
	void PickUp();
	void PutDown();
	void Adjust(float dx);
	static Slider* GetPickedUp();
private:
	enum Type {PERCENT, DISCRETE};
	Type m_type;
	std::string m_label;
	void DrawQuad(float x, float y, float width, float height);
	void DrawMarker(float x, float y);
	static const int MARKSIZE = 5;
	static const int SLIDER_LMARGIN = 200;
	static const int SLIDER_TMARGIN = 50;
	static const int SLIDER_SPACE_LBL_BAR = 10; //spacing btwn label and bar
	static const int SLIDER_WIDTH = 300;
	static const int SLIDER_VSPACING = 20;
	unsigned int m_hi;
	unsigned int m_lo;
	float* m_percent;
	unsigned int* m_discrete;
	void* m_dataPtr;
	bool m_picked_up;
	static Slider* s_picked_up;
	float dragDelta;
};