#pragma once
#include <string>

class Texture
{
public:
	Texture(): m_loaded(0) {}
	~Texture() {}
	bool Create(unsigned int width, unsigned int height);
	bool CreateUnfilled();
	bool CreateDepth(unsigned int width, unsigned int height);
	bool IsLoaded() {return m_loaded;}
	bool Load(std::string path, std::string fileName);
	bool LoadCubemap(std::string prefix, std::string extension);
	unsigned int GetId() {return m_id;}
	std::string GetName() {return m_name;}
	void Free();
	float GetWidth() {return m_width;}
	float GetHeight() {return m_height;}
private:
	float m_width, m_height;
	bool m_loaded;
	unsigned int m_id;
	std::string m_name;
};