#pragma once

// Return a matrix to represent a counterclockwise rotation of "angle"
// degrees around the axis "axis", where "axis" is one of the
// characters 'x', 'y', or 'z'.
// This function expects degrees.
Matrix4x4 rotationDeg(double angle, char axis);
Matrix4x4 rotationRad(double angle, char axis);

// Return a matrix to represent a displacement of the given vector.
Matrix4x4 translation(const Vector3D& displacement);

// Return a matrix to represent a nonuniform scale with the given factors.
Matrix4x4 scaling(const Vector3D& scale);

Matrix4x4 perspective(double fov, double aspect, double zNear, double zFar); 

Matrix4x4 lookAt(Vector3D view, Vector3D up);